import unit4.collectionsLib.*;
public class Deque<T>
{
	private Node<T> left;
	private Node<T> right;
	
	public Deque()
	{
		this.left=null;
		this.right=null;
	}
	
	public boolean isEmpty()
	{
		return this.left==null && this.right==null;
	}
	
	public void insertRight (T x)
	{
		Node<T> temp=new Node<T> (x);
		
			this.right.setNext(temp);
			this.right=temp;
			if (this.left==null)
				this.left=temp;
			
		}
	
	public void insertLeft (T x)
	{
		this.left=new Node<T>(x, this.left);
	}
	
	public T removeRight()
	{
		T x=this.right.getInfo();
		Node<T> pos=this.left;
		while (pos.getNext()!=this.right)
			pos=pos.getNext();
		
		pos.setNext(null);
		this.right=pos;

		return x;
	}
	
	public T removeLeft()
	{
		T x=this.left.getInfo();
		this.left=this.left.getNext();
		return x;
	}
	
	public String toString()
	{
		String str="[";
		Node<T> pos=this.left;
		while (pos!=null)
		{
			str+=pos.getInfo().toString();
			if (pos.getNext()!=null)
				str=str+",";
			pos=pos.getNext();
		}
		str+="]";
		return str;
	}
	
	
}
